/* A Bison parser, made by GNU Bison 2.5.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with json_yy_ or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "jsongrm.y"

/* This file is part of Eclat.
   Copyright (C) 2012-2015 Sergey Poznyakoff.
 
   Eclat is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Eclat is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Eclat.  If not, see <http://www.gnu.org/licenses/>. */

#include "libeclat.h"
#include <string.h>
#include "jsongrm.h"
#include "json.h"

struct json_object *json_return_obj;

static int json_yy_error(char const *s);

static struct json_pair *
pairdup(struct json_pair *in)
{
	struct json_pair *out = grecs_malloc(sizeof(*out));
	out->k = in->k;
	out->v = in->v;
	return out;
}

static void
pairfree(void *ptr)
{
	struct json_pair *p = ptr;
	free(p->k);
	json_object_free(p->v);
	free(p);
}

static void
objfree(void *ptr)
{
	struct json_object *o = ptr;
	json_object_free(o);
}



/* Line 268 of yacc.c  */
#line 125 "jsongrm.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum json_yy_tokentype {
     T_NUMBER = 258,
     T_STRING = 259,
     T_BOOL = 260,
     T_NULL = 261,
     T_ERR = 262
   };
#endif
/* Tokens.  */
#define T_NUMBER 258
#define T_STRING 259
#define T_BOOL 260
#define T_NULL 261
#define T_ERR 262




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 295 of yacc.c  */
#line 64 "jsongrm.y"

	int b;
	double n;
	char *s;
	struct json_array *a;
	struct grecs_symtab *o;
	struct json_object *obj;
	struct grecs_list *list;
	struct json_pair *p;



/* Line 295 of yacc.c  */
#line 196 "jsongrm.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define json_yy_stype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 345 of yacc.c  */
#line 208 "jsongrm.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 json_yy_type_uint8;
#else
typedef unsigned char json_yy_type_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 json_yy_type_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char json_yy_type_int8;
#else
typedef short int json_yy_type_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 json_yy_type_uint16;
#else
typedef unsigned short int json_yy_type_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 json_yy_type_int16;
#else
typedef short int json_yy_type_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int json_yy_i)
#else
static int
YYID (json_yy_i)
    int json_yy_i;
#endif
{
  return json_yy_i;
}
#endif

#if ! defined json_yy_overflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined json_yy_overflow || YYERROR_VERBOSE */


#if (! defined json_yy_overflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union json_yy_alloc
{
  json_yy_type_int16 json_yy_ss_alloc;
  YYSTYPE json_yy_vs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union json_yy_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (json_yy_type_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T json_yy_newbytes;						\
	YYCOPY (&json_yy_ptr->Stack_alloc, Stack, json_yy_size);			\
	Stack = &json_yy_ptr->Stack_alloc;					\
	json_yy_newbytes = json_yy_stacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	json_yy_ptr += json_yy_newbytes / sizeof (*json_yy_ptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T json_yy_i;                         \
          for (json_yy_i = 0; json_yy_i < (Count); json_yy_i++)   \
            (Dst)[json_yy_i] = (Src)[json_yy_i];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  18
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   17

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  14
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  19
/* YYNRULES -- Number of states.  */
#define YYNSTATES  27

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   262

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? json_yy_translate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const json_yy_type_uint8 json_yy_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    10,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    13,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     8,     2,     9,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    11,     2,    12,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const json_yy_type_uint8 json_yy_prhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    17,
      21,    22,    24,    26,    30,    34,    35,    37,    39,    43
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const json_yy_type_int8 json_yy_rhs[] =
{
      15,     0,    -1,    16,    -1,     3,    -1,     4,    -1,     5,
      -1,     6,    -1,    17,    -1,    20,    -1,     8,    18,     9,
      -1,    -1,    19,    -1,    16,    -1,    19,    10,    16,    -1,
      11,    21,    12,    -1,    -1,    22,    -1,    23,    -1,    22,
      10,    23,    -1,     4,    13,    16,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const json_yy_type_uint8 json_yy_rline[] =
{
       0,    76,    76,    82,    87,    92,    97,   101,   106,   113,
     134,   137,   140,   146,   152,   175,   178,   181,   187,   193
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const json_yy_tname[] =
{
  "$end", "error", "$undefined", "T_NUMBER", "T_STRING", "T_BOOL",
  "T_NULL", "T_ERR", "'['", "']'", "','", "'{'", "'}'", "':'", "$accept",
  "input", "object", "array", "objects", "objlist", "assoc", "pairs",
  "pairlist", "pair", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const json_yy_type_uint16 json_yy_toknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    91,    93,
      44,   123,   125,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const json_yy_type_uint8 json_yy_r1[] =
{
       0,    14,    15,    16,    16,    16,    16,    16,    16,    17,
      18,    18,    19,    19,    20,    21,    21,    22,    22,    23
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const json_yy_type_uint8 json_yy_r2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       0,     1,     1,     3,     3,     0,     1,     1,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const json_yy_type_uint8 json_yy_defact[] =
{
       0,     3,     4,     5,     6,    10,    15,     0,     2,     7,
       8,    12,     0,    11,     0,     0,    16,    17,     1,     9,
       0,     0,    14,     0,    13,    19,    18
};

/* YYDEFGOTO[NTERM-NUM].  */
static const json_yy_type_int8 json_yy_defgoto[] =
{
      -1,     7,     8,     9,    12,    13,    10,    15,    16,    17
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -13
static const json_yy_type_int8 json_yy_pact[] =
{
      -2,   -13,   -13,   -13,   -13,    -2,     1,     7,   -13,   -13,
     -13,   -13,    -1,     0,     4,     2,     3,   -13,   -13,   -13,
      -2,    -2,   -13,     1,   -13,   -13,   -13
};

/* YYPGOTO[NTERM-NUM].  */
static const json_yy_type_int8 json_yy_pgoto[] =
{
     -13,   -13,    -5,   -13,   -13,   -13,   -13,   -13,   -13,   -12
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const json_yy_type_uint8 json_yy_table[] =
{
      11,     1,     2,     3,     4,    14,     5,    18,    19,     6,
      20,    26,     0,    23,    22,    24,    25,    21
};

#define json_yy_pact_value_is_default(json_yy_state) \
  ((json_yy_state) == (-13))

#define json_yy_table_value_is_error(json_yy_table_value) \
  YYID (0)

static const json_yy_type_int8 json_yy_check[] =
{
       5,     3,     4,     5,     6,     4,     8,     0,     9,    11,
      10,    23,    -1,    10,    12,    20,    21,    13
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const json_yy_type_uint8 json_yy_stos[] =
{
       0,     3,     4,     5,     6,     8,    11,    15,    16,    17,
      20,    16,    18,    19,     4,    21,    22,    23,     0,     9,
      10,    13,    12,    10,    16,    16,    23
};

#define json_yy_errok		(json_yy_errstatus = 0)
#define json_yy_clearin	(json_yy_char = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto json_yy_acceptlab
#define YYABORT		goto json_yy_abortlab
#define YYERROR		goto json_yy_errorlab


/* Like YYERROR except do call json_yy_error.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto json_yy_errlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!json_yy_errstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (json_yy_char == YYEMPTY)                                        \
    {                                                           \
      json_yy_char = (Token);                                         \
      json_yy_lval = (Value);                                         \
      YYPOPSTACK (json_yy_len);                                       \
      json_yy_state = *json_yy_ssp;                                         \
      goto json_yy_backup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      json_yy_error (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `json_yy_lex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX json_yy_lex (YYLEX_PARAM)
#else
# define YYLEX json_yy_lex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (json_yy_debug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (json_yy_debug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      json_yy__symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
json_yy__symbol_value_print (FILE *json_yy_output, int json_yy_type, YYSTYPE const * const json_yy_valuep)
#else
static void
json_yy__symbol_value_print (json_yy_output, json_yy_type, json_yy_valuep)
    FILE *json_yy_output;
    int json_yy_type;
    YYSTYPE const * const json_yy_valuep;
#endif
{
  FILE *json_yy_o = json_yy_output;
  YYUSE (json_yy_o);
  if (!json_yy_valuep)
    return;
# ifdef YYPRINT
  if (json_yy_type < YYNTOKENS)
    YYPRINT (json_yy_output, json_yy_toknum[json_yy_type], *json_yy_valuep);
# else
  YYUSE (json_yy_output);
# endif
  switch (json_yy_type)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
json_yy__symbol_print (FILE *json_yy_output, int json_yy_type, YYSTYPE const * const json_yy_valuep)
#else
static void
json_yy__symbol_print (json_yy_output, json_yy_type, json_yy_valuep)
    FILE *json_yy_output;
    int json_yy_type;
    YYSTYPE const * const json_yy_valuep;
#endif
{
  if (json_yy_type < YYNTOKENS)
    YYFPRINTF (json_yy_output, "token %s (", json_yy_tname[json_yy_type]);
  else
    YYFPRINTF (json_yy_output, "nterm %s (", json_yy_tname[json_yy_type]);

  json_yy__symbol_value_print (json_yy_output, json_yy_type, json_yy_valuep);
  YYFPRINTF (json_yy_output, ")");
}

/*------------------------------------------------------------------.
| json_yy__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
json_yy__stack_print (json_yy_type_int16 *json_yy_bottom, json_yy_type_int16 *json_yy_top)
#else
static void
json_yy__stack_print (json_yy_bottom, json_yy_top)
    json_yy_type_int16 *json_yy_bottom;
    json_yy_type_int16 *json_yy_top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; json_yy_bottom <= json_yy_top; json_yy_bottom++)
    {
      int json_yy_bot = *json_yy_bottom;
      YYFPRINTF (stderr, " %d", json_yy_bot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (json_yy_debug)							\
    json_yy__stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
json_yy__reduce_print (YYSTYPE *json_yy_vsp, int json_yy_rule)
#else
static void
json_yy__reduce_print (json_yy_vsp, json_yy_rule)
    YYSTYPE *json_yy_vsp;
    int json_yy_rule;
#endif
{
  int json_yy_nrhs = json_yy_r2[json_yy_rule];
  int json_yy_i;
  unsigned long int json_yy_lno = json_yy_rline[json_yy_rule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     json_yy_rule - 1, json_yy_lno);
  /* The symbols being reduced.  */
  for (json_yy_i = 0; json_yy_i < json_yy_nrhs; json_yy_i++)
    {
      YYFPRINTF (stderr, "   $%d = ", json_yy_i + 1);
      json_yy__symbol_print (stderr, json_yy_rhs[json_yy_prhs[json_yy_rule] + json_yy_i],
		       &(json_yy_vsp[(json_yy_i + 1) - (json_yy_nrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (json_yy_debug)				\
    json_yy__reduce_print (json_yy_vsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int json_yy_debug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef json_yy_strlen
#  if defined __GLIBC__ && defined _STRING_H
#   define json_yy_strlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
json_yy_strlen (const char *json_yy_str)
#else
static YYSIZE_T
json_yy_strlen (json_yy_str)
    const char *json_yy_str;
#endif
{
  YYSIZE_T json_yy_len;
  for (json_yy_len = 0; json_yy_str[json_yy_len]; json_yy_len++)
    continue;
  return json_yy_len;
}
#  endif
# endif

# ifndef json_yy_stpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define json_yy_stpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
json_yy_stpcpy (char *json_yy_dest, const char *json_yy_src)
#else
static char *
json_yy_stpcpy (json_yy_dest, json_yy_src)
    char *json_yy_dest;
    const char *json_yy_src;
#endif
{
  char *json_yy_d = json_yy_dest;
  const char *json_yy_s = json_yy_src;

  while ((*json_yy_d++ = *json_yy_s++) != '\0')
    continue;

  return json_yy_d - 1;
}
#  endif
# endif

# ifndef json_yy_tnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for json_yy_error.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from json_yy_tname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
json_yy_tnamerr (char *json_yy_res, const char *json_yy_str)
{
  if (*json_yy_str == '"')
    {
      YYSIZE_T json_yy_n = 0;
      char const *json_yy_p = json_yy_str;

      for (;;)
	switch (*++json_yy_p)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++json_yy_p != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (json_yy_res)
	      json_yy_res[json_yy_n] = *json_yy_p;
	    json_yy_n++;
	    break;

	  case '"':
	    if (json_yy_res)
	      json_yy_res[json_yy_n] = '\0';
	    return json_yy_n;
	  }
    do_not_strip_quotes: ;
    }

  if (! json_yy_res)
    return json_yy_strlen (json_yy_str);

  return json_yy_stpcpy (json_yy_res, json_yy_str) - json_yy_res;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
json_yy_syntax_error (YYSIZE_T *json_yy_msg_alloc, char **json_yy_msg,
                json_yy_type_int16 *json_yy_ssp, int json_yy_token)
{
  YYSIZE_T json_yy_size0 = json_yy_tnamerr (YY_NULL, json_yy_tname[json_yy_token]);
  YYSIZE_T json_yy_size = json_yy_size0;
  YYSIZE_T json_yy_size1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *json_yy_format = YY_NULL;
  /* Arguments of json_yy_format. */
  char const *json_yy_arg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int json_yy_count = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in json_yy_char) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated json_yy_char.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (json_yy_token != YYEMPTY)
    {
      int json_yy_n = json_yy_pact[*json_yy_ssp];
      json_yy_arg[json_yy_count++] = json_yy_tname[json_yy_token];
      if (!json_yy_pact_value_is_default (json_yy_n))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int json_yy_xbegin = json_yy_n < 0 ? -json_yy_n : 0;
          /* Stay within bounds of both json_yy_check and json_yy_tname.  */
          int json_yy_checklim = YYLAST - json_yy_n + 1;
          int json_yy_xend = json_yy_checklim < YYNTOKENS ? json_yy_checklim : YYNTOKENS;
          int json_yy_x;

          for (json_yy_x = json_yy_xbegin; json_yy_x < json_yy_xend; ++json_yy_x)
            if (json_yy_check[json_yy_x + json_yy_n] == json_yy_x && json_yy_x != YYTERROR
                && !json_yy_table_value_is_error (json_yy_table[json_yy_x + json_yy_n]))
              {
                if (json_yy_count == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    json_yy_count = 1;
                    json_yy_size = json_yy_size0;
                    break;
                  }
                json_yy_arg[json_yy_count++] = json_yy_tname[json_yy_x];
                json_yy_size1 = json_yy_size + json_yy_tnamerr (YY_NULL, json_yy_tname[json_yy_x]);
                if (! (json_yy_size <= json_yy_size1
                       && json_yy_size1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                json_yy_size = json_yy_size1;
              }
        }
    }

  switch (json_yy_count)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        json_yy_format = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  json_yy_size1 = json_yy_size + json_yy_strlen (json_yy_format);
  if (! (json_yy_size <= json_yy_size1 && json_yy_size1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  json_yy_size = json_yy_size1;

  if (*json_yy_msg_alloc < json_yy_size)
    {
      *json_yy_msg_alloc = 2 * json_yy_size;
      if (! (json_yy_size <= *json_yy_msg_alloc
             && *json_yy_msg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *json_yy_msg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *json_yy_p = *json_yy_msg;
    int json_yy_i = 0;
    while ((*json_yy_p = *json_yy_format) != '\0')
      if (*json_yy_p == '%' && json_yy_format[1] == 's' && json_yy_i < json_yy_count)
        {
          json_yy_p += json_yy_tnamerr (json_yy_p, json_yy_arg[json_yy_i++]);
          json_yy_format += 2;
        }
      else
        {
          json_yy_p++;
          json_yy_format++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
json_yy_destruct (const char *json_yy_msg, int json_yy_type, YYSTYPE *json_yy_valuep)
#else
static void
json_yy_destruct (json_yy_msg, json_yy_type, json_yy_valuep)
    const char *json_yy_msg;
    int json_yy_type;
    YYSTYPE *json_yy_valuep;
#endif
{
  YYUSE (json_yy_valuep);

  if (!json_yy_msg)
    json_yy_msg = "Deleting";
  YY_SYMBOL_PRINT (json_yy_msg, json_yy_type, json_yy_valuep, json_yy_locationp);

  switch (json_yy_type)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int json_yy_parse (void *YYPARSE_PARAM);
#else
int json_yy_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int json_yy_parse (void);
#else
int json_yy_parse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int json_yy_char;

/* The semantic value of the lookahead symbol.  */
YYSTYPE json_yy_lval;

/* Number of syntax errors so far.  */
int json_yy_nerrs;


/*----------.
| json_yy_parse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
json_yy_parse (void *YYPARSE_PARAM)
#else
int
json_yy_parse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
json_yy_parse (void)
#else
int
json_yy_parse ()

#endif
#endif
{
    int json_yy_state;
    /* Number of tokens to shift before error messages enabled.  */
    int json_yy_errstatus;

    /* The stacks and their tools:
       `json_yy_ss': related to states.
       `json_yy_vs': related to semantic values.

       Refer to the stacks through separate pointers, to allow json_yy_overflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    json_yy_type_int16 json_yy_ssa[YYINITDEPTH];
    json_yy_type_int16 *json_yy_ss;
    json_yy_type_int16 *json_yy_ssp;

    /* The semantic value stack.  */
    YYSTYPE json_yy_vsa[YYINITDEPTH];
    YYSTYPE *json_yy_vs;
    YYSTYPE *json_yy_vsp;

    YYSIZE_T json_yy_stacksize;

  int json_yy_n;
  int json_yy_result;
  /* Lookahead token as an internal (translated) token number.  */
  int json_yy_token;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE json_yy_val;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char json_yy_msgbuf[128];
  char *json_yy_msg = json_yy_msgbuf;
  YYSIZE_T json_yy_msg_alloc = sizeof json_yy_msgbuf;
#endif

#define YYPOPSTACK(N)   (json_yy_vsp -= (N), json_yy_ssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int json_yy_len = 0;

  json_yy_token = 0;
  json_yy_ss = json_yy_ssa;
  json_yy_vs = json_yy_vsa;
  json_yy_stacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  json_yy_state = 0;
  json_yy_errstatus = 0;
  json_yy_nerrs = 0;
  json_yy_char = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  json_yy_ssp = json_yy_ss;
  json_yy_vsp = json_yy_vs;

  goto json_yy_setstate;

/*------------------------------------------------------------.
| json_yy_newstate -- Push a new state, which is found in json_yy_state.  |
`------------------------------------------------------------*/
 json_yy_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  json_yy_ssp++;

 json_yy_setstate:
  *json_yy_ssp = json_yy_state;

  if (json_yy_ss + json_yy_stacksize - 1 <= json_yy_ssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T json_yy_size = json_yy_ssp - json_yy_ss + 1;

#ifdef json_yy_overflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *json_yy_vs1 = json_yy_vs;
	json_yy_type_int16 *json_yy_ss1 = json_yy_ss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if json_yy_overflow is a macro.  */
	json_yy_overflow (YY_("memory exhausted"),
		    &json_yy_ss1, json_yy_size * sizeof (*json_yy_ssp),
		    &json_yy_vs1, json_yy_size * sizeof (*json_yy_vsp),
		    &json_yy_stacksize);

	json_yy_ss = json_yy_ss1;
	json_yy_vs = json_yy_vs1;
      }
#else /* no json_yy_overflow */
# ifndef YYSTACK_RELOCATE
      goto json_yy_exhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= json_yy_stacksize)
	goto json_yy_exhaustedlab;
      json_yy_stacksize *= 2;
      if (YYMAXDEPTH < json_yy_stacksize)
	json_yy_stacksize = YYMAXDEPTH;

      {
	json_yy_type_int16 *json_yy_ss1 = json_yy_ss;
	union json_yy_alloc *json_yy_ptr =
	  (union json_yy_alloc *) YYSTACK_ALLOC (YYSTACK_BYTES (json_yy_stacksize));
	if (! json_yy_ptr)
	  goto json_yy_exhaustedlab;
	YYSTACK_RELOCATE (json_yy_ss_alloc, json_yy_ss);
	YYSTACK_RELOCATE (json_yy_vs_alloc, json_yy_vs);
#  undef YYSTACK_RELOCATE
	if (json_yy_ss1 != json_yy_ssa)
	  YYSTACK_FREE (json_yy_ss1);
      }
# endif
#endif /* no json_yy_overflow */

      json_yy_ssp = json_yy_ss + json_yy_size - 1;
      json_yy_vsp = json_yy_vs + json_yy_size - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) json_yy_stacksize));

      if (json_yy_ss + json_yy_stacksize - 1 <= json_yy_ssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", json_yy_state));

  if (json_yy_state == YYFINAL)
    YYACCEPT;

  goto json_yy_backup;

/*-----------.
| json_yy_backup.  |
`-----------*/
json_yy_backup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  json_yy_n = json_yy_pact[json_yy_state];
  if (json_yy_pact_value_is_default (json_yy_n))
    goto json_yy_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (json_yy_char == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      json_yy_char = YYLEX;
    }

  if (json_yy_char <= YYEOF)
    {
      json_yy_char = json_yy_token = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      json_yy_token = YYTRANSLATE (json_yy_char);
      YY_SYMBOL_PRINT ("Next token is", json_yy_token, &json_yy_lval, &json_yy_lloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  json_yy_n += json_yy_token;
  if (json_yy_n < 0 || YYLAST < json_yy_n || json_yy_check[json_yy_n] != json_yy_token)
    goto json_yy_default;
  json_yy_n = json_yy_table[json_yy_n];
  if (json_yy_n <= 0)
    {
      if (json_yy_table_value_is_error (json_yy_n))
        goto json_yy_errlab;
      json_yy_n = -json_yy_n;
      goto json_yy_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (json_yy_errstatus)
    json_yy_errstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", json_yy_token, &json_yy_lval, &json_yy_lloc);

  /* Discard the shifted token.  */
  json_yy_char = YYEMPTY;

  json_yy_state = json_yy_n;
  *++json_yy_vsp = json_yy_lval;

  goto json_yy_newstate;


/*-----------------------------------------------------------.
| json_yy_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
json_yy_default:
  json_yy_n = json_yy_defact[json_yy_state];
  if (json_yy_n == 0)
    goto json_yy_errlab;
  goto json_yy_reduce;


/*-----------------------------.
| json_yy_reduce -- Do a reduction.  |
`-----------------------------*/
json_yy_reduce:
  /* json_yy_n is the number of a rule to reduce with.  */
  json_yy_len = json_yy_r2[json_yy_n];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  json_yy_val = json_yy_vsp[1-json_yy_len];


  YY_REDUCE_PRINT (json_yy_n);
  switch (json_yy_n)
    {
        case 2:

/* Line 1810 of yacc.c  */
#line 77 "jsongrm.y"
    {
		  json_return_obj = (json_yy_vsp[(1) - (1)].obj);
	  }
    break;

  case 3:

/* Line 1810 of yacc.c  */
#line 83 "jsongrm.y"
    {
	      (json_yy_val.obj) = json_object_create(json_number);
	      (json_yy_val.obj)->v.n = (json_yy_vsp[(1) - (1)].n);
          }
    break;

  case 4:

/* Line 1810 of yacc.c  */
#line 88 "jsongrm.y"
    {
	      (json_yy_val.obj) = json_object_create(json_string);
	      (json_yy_val.obj)->v.s = (json_yy_vsp[(1) - (1)].s);
          }
    break;

  case 5:

/* Line 1810 of yacc.c  */
#line 93 "jsongrm.y"
    {
	      (json_yy_val.obj) = json_object_create(json_bool);
	      (json_yy_val.obj)->v.b = (json_yy_vsp[(1) - (1)].b);
          }
    break;

  case 6:

/* Line 1810 of yacc.c  */
#line 98 "jsongrm.y"
    {
	      (json_yy_val.obj) = json_object_create(json_null);
          }
    break;

  case 7:

/* Line 1810 of yacc.c  */
#line 102 "jsongrm.y"
    {
	      (json_yy_val.obj) = json_object_create(json_arr);
	      (json_yy_val.obj)->v.a = (json_yy_vsp[(1) - (1)].a);
          }
    break;

  case 8:

/* Line 1810 of yacc.c  */
#line 107 "jsongrm.y"
    {
	      (json_yy_val.obj) = json_object_create(json_obj);
	      (json_yy_val.obj)->v.o = (json_yy_vsp[(1) - (1)].o);
          }
    break;

  case 9:

/* Line 1810 of yacc.c  */
#line 114 "jsongrm.y"
    {
	       struct json_array *a = grecs_malloc(sizeof(*a));
	       if (!(json_yy_vsp[(2) - (3)].list)) {
	           a->oc = 0;
		   a->ov = NULL;
               } else {
	           size_t i;
	           struct grecs_list_entry *ep;
	           a->oc = (json_yy_vsp[(2) - (3)].list)->count;
		   a->ov = grecs_calloc(a->oc, sizeof(a->ov));
                   for (i = 0, ep = (json_yy_vsp[(2) - (3)].list)->head; ep; i++, ep = ep->next) {
	              struct json_object *p = ep->data;
		      a->ov[i] = p;
                   }
               }
	       (json_yy_val.a) = a;
          }
    break;

  case 10:

/* Line 1810 of yacc.c  */
#line 134 "jsongrm.y"
    {
	       (json_yy_val.list) = NULL;
          }
    break;

  case 12:

/* Line 1810 of yacc.c  */
#line 141 "jsongrm.y"
    {
	       (json_yy_val.list) = grecs_list_create();
	       (json_yy_val.list)->free_entry = objfree;
 	       grecs_list_append((json_yy_val.list), (json_yy_vsp[(1) - (1)].obj));
          }
    break;

  case 13:

/* Line 1810 of yacc.c  */
#line 147 "jsongrm.y"
    {
 	       grecs_list_append((json_yy_vsp[(1) - (3)].list), (json_yy_vsp[(3) - (3)].obj));
          }
    break;

  case 14:

/* Line 1810 of yacc.c  */
#line 153 "jsongrm.y"
    {
	      struct grecs_symtab *s;

	      s = json_assoc_create();
	      if ((json_yy_vsp[(2) - (3)].list)) {
	          struct grecs_list_entry *ep;
                  for (ep = (json_yy_vsp[(2) - (3)].list)->head; ep; ep = ep->next) {
	              struct json_pair *p = ep->data;
		      int install = 1;
		      grecs_symtab_lookup_or_install(s, p, &install);
		      if (install) {
	                  p->k = NULL;
			  p->v = NULL;
                      }
                  }
		  grecs_list_free((json_yy_vsp[(2) - (3)].list));
              }
	      (json_yy_val.o) = s;
          }
    break;

  case 15:

/* Line 1810 of yacc.c  */
#line 175 "jsongrm.y"
    {
	       (json_yy_val.list) = NULL;
          }
    break;

  case 17:

/* Line 1810 of yacc.c  */
#line 182 "jsongrm.y"
    {
	       (json_yy_val.list) = grecs_list_create();
	       (json_yy_val.list)->free_entry = pairfree;
 	       grecs_list_append((json_yy_val.list), (json_yy_vsp[(1) - (1)].p));
          }
    break;

  case 18:

/* Line 1810 of yacc.c  */
#line 188 "jsongrm.y"
    {
 	       grecs_list_append((json_yy_vsp[(1) - (3)].list), (json_yy_vsp[(3) - (3)].p));
          }
    break;

  case 19:

/* Line 1810 of yacc.c  */
#line 194 "jsongrm.y"
    {
	       struct json_pair *p = grecs_malloc(sizeof(*p));
	       p->k = (json_yy_vsp[(1) - (3)].s);
	       p->v = (json_yy_vsp[(3) - (3)].obj);
	       (json_yy_val.p) = p;
          }
    break;



/* Line 1810 of yacc.c  */
#line 1627 "jsongrm.c"
      default: break;
    }
  /* User semantic actions sometimes alter json_yy_char, and that requires
     that json_yy_token be updated with the new translation.  We take the
     approach of translating immediately before every use of json_yy_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering json_yy_char or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", json_yy_r1[json_yy_n], &json_yy_val, &json_yy_loc);

  YYPOPSTACK (json_yy_len);
  json_yy_len = 0;
  YY_STACK_PRINT (json_yy_ss, json_yy_ssp);

  *++json_yy_vsp = json_yy_val;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  json_yy_n = json_yy_r1[json_yy_n];

  json_yy_state = json_yy_pgoto[json_yy_n - YYNTOKENS] + *json_yy_ssp;
  if (0 <= json_yy_state && json_yy_state <= YYLAST && json_yy_check[json_yy_state] == *json_yy_ssp)
    json_yy_state = json_yy_table[json_yy_state];
  else
    json_yy_state = json_yy_defgoto[json_yy_n - YYNTOKENS];

  goto json_yy_newstate;


/*------------------------------------.
| json_yy_errlab -- here on detecting error |
`------------------------------------*/
json_yy_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  json_yy_token = json_yy_char == YYEMPTY ? YYEMPTY : YYTRANSLATE (json_yy_char);

  /* If not already recovering from an error, report this error.  */
  if (!json_yy_errstatus)
    {
      ++json_yy_nerrs;
#if ! YYERROR_VERBOSE
      json_yy_error (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR json_yy_syntax_error (&json_yy_msg_alloc, &json_yy_msg, \
                                        json_yy_ssp, json_yy_token)
      {
        char const *json_yy_msgp = YY_("syntax error");
        int json_yy_syntax_error_status;
        json_yy_syntax_error_status = YYSYNTAX_ERROR;
        if (json_yy_syntax_error_status == 0)
          json_yy_msgp = json_yy_msg;
        else if (json_yy_syntax_error_status == 1)
          {
            if (json_yy_msg != json_yy_msgbuf)
              YYSTACK_FREE (json_yy_msg);
            json_yy_msg = (char *) YYSTACK_ALLOC (json_yy_msg_alloc);
            if (!json_yy_msg)
              {
                json_yy_msg = json_yy_msgbuf;
                json_yy_msg_alloc = sizeof json_yy_msgbuf;
                json_yy_syntax_error_status = 2;
              }
            else
              {
                json_yy_syntax_error_status = YYSYNTAX_ERROR;
                json_yy_msgp = json_yy_msg;
              }
          }
        json_yy_error (json_yy_msgp);
        if (json_yy_syntax_error_status == 2)
          goto json_yy_exhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (json_yy_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (json_yy_char <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (json_yy_char == YYEOF)
	    YYABORT;
	}
      else
	{
	  json_yy_destruct ("Error: discarding",
		      json_yy_token, &json_yy_lval);
	  json_yy_char = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto json_yy_errlab1;


/*---------------------------------------------------.
| json_yy_errorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
json_yy_errorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label json_yy_errorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto json_yy_errorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (json_yy_len);
  json_yy_len = 0;
  YY_STACK_PRINT (json_yy_ss, json_yy_ssp);
  json_yy_state = *json_yy_ssp;
  goto json_yy_errlab1;


/*-------------------------------------------------------------.
| json_yy_errlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
json_yy_errlab1:
  json_yy_errstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      json_yy_n = json_yy_pact[json_yy_state];
      if (!json_yy_pact_value_is_default (json_yy_n))
	{
	  json_yy_n += YYTERROR;
	  if (0 <= json_yy_n && json_yy_n <= YYLAST && json_yy_check[json_yy_n] == YYTERROR)
	    {
	      json_yy_n = json_yy_table[json_yy_n];
	      if (0 < json_yy_n)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (json_yy_ssp == json_yy_ss)
	YYABORT;


      json_yy_destruct ("Error: popping",
		  json_yy_stos[json_yy_state], json_yy_vsp);
      YYPOPSTACK (1);
      json_yy_state = *json_yy_ssp;
      YY_STACK_PRINT (json_yy_ss, json_yy_ssp);
    }

  *++json_yy_vsp = json_yy_lval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", json_yy_stos[json_yy_n], json_yy_vsp, json_yy_lsp);

  json_yy_state = json_yy_n;
  goto json_yy_newstate;


/*-------------------------------------.
| json_yy_acceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
json_yy_acceptlab:
  json_yy_result = 0;
  goto json_yy_return;

/*-----------------------------------.
| json_yy_abortlab -- YYABORT comes here.  |
`-----------------------------------*/
json_yy_abortlab:
  json_yy_result = 1;
  goto json_yy_return;

#if !defined json_yy_overflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| json_yy_exhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
json_yy_exhaustedlab:
  json_yy_error (YY_("memory exhausted"));
  json_yy_result = 2;
  /* Fall through.  */
#endif

json_yy_return:
  if (json_yy_char != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      json_yy_token = YYTRANSLATE (json_yy_char);
      json_yy_destruct ("Cleanup: discarding lookahead",
                  json_yy_token, &json_yy_lval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (json_yy_len);
  YY_STACK_PRINT (json_yy_ss, json_yy_ssp);
  while (json_yy_ssp != json_yy_ss)
    {
      json_yy_destruct ("Cleanup: popping",
		  json_yy_stos[*json_yy_ssp], json_yy_vsp);
      YYPOPSTACK (1);
    }
#ifndef json_yy_overflow
  if (json_yy_ss != json_yy_ssa)
    YYSTACK_FREE (json_yy_ss);
#endif
#if YYERROR_VERBOSE
  if (json_yy_msg != json_yy_msgbuf)
    YYSTACK_FREE (json_yy_msg);
#endif
  /* Make sure YYID is used.  */
  return YYID (json_yy_result);
}



/* Line 2071 of yacc.c  */
#line 201 "jsongrm.y"


static int
json_yy_error(char const *s)
{
	jsonlex_diag(s, 0);
	return 0;
}

struct json_object *
json_object_create(int type)
{
	struct json_object *obj = grecs_zalloc(sizeof(*obj));
	obj->type = type;
	return obj;
}

void
json_object_free(struct json_object *obj)
{
	size_t i;
	
	if (!obj)
		return;

	switch (obj->type) {
        case json_bool:
        case json_number:
		break;
	case json_string:
		free(obj->v.s);
		break;
	case json_arr:
		for (i = 0; i < obj->v.a->oc; i++)
			json_object_free(obj->v.a->ov[i]);
		free(obj->v.a);
		break;
	case json_obj:
		grecs_symtab_free(obj->v.o);
	}
	free(obj);
}

static unsigned
json_st_hash(void *data, unsigned long n_buckets)
{
	struct json_pair *p = data;
	return grecs_hash_string(p->k, n_buckets);
}	

static int
json_st_cmp(const void *a, const void *b)
{
	struct json_pair const *pa = a;
	struct json_pair const *pb = b;
	return strcmp(pa->k, pb->k);
}

static int
json_st_copy(void *a, void *b)
{
	struct json_pair *pa = a;
	struct json_pair *pb = b;
	memcpy(pa, pb, sizeof(*pa));
	return 0;
}

static void
json_st_free(void *ptr)
{
	struct json_pair *p = ptr;
//	printf("FREE %s\n", p->k);
	free(p->k);
	json_object_free(p->v);
	free(p);
}

struct grecs_symtab *
json_assoc_create()
{
	return grecs_symtab_create(sizeof(struct json_pair),
				   json_st_hash,
				   json_st_cmp,
				   json_st_copy,
				   NULL,
				   json_st_free);
}

struct json_object *
json_parse_string(char const *input, size_t len)
{
	jsonlex_setup(input, len);
	if (json_yy_parse()) {
		/* FIXME: error recovery */
		return NULL;
	}
	return json_return_obj;
}

struct json_object *
json_object_lookup(struct json_object *obj, const char *ident)
{
	struct json_pair key, *p;
	if (!obj || obj->type != json_obj)
		return NULL;
	key.k = ident;
	p = grecs_symtab_lookup_or_install(obj->v.o, &key, NULL);
	if (!p)
		return NULL;
	return p->v;
}



	
		  

